
/*

Turbo C v2.0  Checkers Program

Author			Matt Voight
Date			4 / 15 / 91
Version			1.01			*/


#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>
#include <keys.h>

int  plyr,quitgame,kings[2],
	 board[8][8],pieces_taken[2],
	 plyr_chk;
char playr[2][10];

int  cnum,cx[10],cy[10],cjmp;

title_screen();
init_variables();
init_playrs();
int load_game();
save_game();
int winner(int);
int quit_program();
beep();

main()
{
	 init_variables();
	 title_screen();
	 information(TRUE);
	 while (!quitgame)
	 {    switch (getch())
		  {     case F1:  center("You must start a new game first");
						  beep();
						  delay(1200);
						  clrtext();
						  break;
				case F2:  check_players();
						  init_playrs();
						  if (move()>-1)
							winner(plyr);
						  break;
				case F3:  if (load_game())
						  {	   int x,y,a;

							   for (y=0;y<8;y++)
							   {   if (y==0 || y==2 || y==4 || y==6)
									   a=0;
								   else
									   a=1;
								   for (x=a;x<8;x+=2)
								   {   clear_square(x,y);
									   if (board[x][y]!=-1)
										   put_piece(x,y,board[x][y]); } }
							   information(TRUE);
							   if (move()>-1)
									winner(plyr); }
						  break;
				case F4:  save_game();break;
				case F5:  plyr_chk=FALSE;
						  check_players();
						  break;
				case F10: quitgame=quit_program(); } }
     restorecrtmode();
}

int rnd(int small,int big)
{	register int a;

	do a=random(big)+1; while (a<small);
	return a; }

beep()
{	sound(1000);
	delay(100);
	nosound(); }

fill(int x,int y,int style,int colr,int bordr)
{    setfillstyle(style,colr);
     floodfill(x,y,bordr); }

title_screen()
{	int  a=3,b=1;
	FILE *fname;

	initgraph(&a,&b,"");
	printf("Please wait...");
	setactivepage(1);
	setcolor(7);
	for (a=5;a<485;a+=59)
		line(a+75,56,a+75,335);
	for (a=55;a<345;a+=35)
		line(80,a,552,a);
	for (a=0;a<8;a++)
	{	register int x,n;

		if (a==1 || a==3 ||
			a==5 || a==7)
			n=80;
		else
			n=139;
		for (x=n;x<515;x+=118)
			fill(x+30,(a*35)+73,1,12,7); }
	setcolor(15);
	rectangle(79,55,553,336);
	rectangle(10,5,630,50);
	fill(320,25,1,0,15);
	rectangle(14,8,626,47);
	rectangle(190,70,450,320);
	fill(320,160,1,0,15);
	rectangle(194,73,446,317);
	fill(10,320,9,9,15);
	settextstyle(1,0,0);
	setusercharsize(2,1,1,1);
	setcolor(3);
	outtextxy(93,7,"Turbo Checkers");
	setcolor(11);
	outtextxy(86,11,"Turbo Checkers");
	settextstyle(2,0,0);
	setusercharsize(1,1,1,1);
	setcolor(7);
	outtextxy(235,85,"Author . . . . . . Matt Voight");
	outtextxy(235,100,"Version . . . . . . . .  1 . 0");
	outtextxy(235,115,"Date . . . . . . .04 / 25 / 91");
	settextstyle(0,0,0);
	outtextxy(202,150,"You must first enter the names");
	outtextxy(202,162,"of the players before playing ");
	outtextxy(202,174,"a game.  As soon as you press ");
	outtextxy(202,186,"<ESC> the game is over.  To");
	outtextxy(202,198,"play the computer just enter");
	outtextxy(202,210,"the name 'computer' as one of");
	outtextxy(202,222,"the players.");
	setvisualpage(1);
	delay(700);
	if ((fname=fopen("signture.img","r"))!=NULL)
	{	int x,y;

		while (!feof(fname))
		{	fscanf(fname,"%d,%d,",&x,&y);
			putpixel(x-20,y+55,15); }
		fclose(fname); }
	init_screen();
	setactivepage(1);
	settextstyle(0,0,0);
	setusercharsize(1,1,1,1);
	setcolor(7);
	outtextxy(202,300,"Do you want instructions?");
	if (tolower(getch())=='y')
		instructions();
	setactivepage(0);
	setvisualpage(0); }

init_screen()
{	delay(1);
	setactivepage(0);
	cleardevice();
	setcolor(15);
	line(1,15,639,15);
	rectangle(490,36,625,316);
	rectangle(5,36,477,315);
	rectangle(40,320,600,339);
	fill(1,20,9,9,15);
	setcolor(0);
	rectangle(5,36,477,315);
	settextstyle(2,0,0);
	setcolor(11);
	outtextxy(100,2,"Turbo C v2.0                           by Matt Voight                   <ESC> to end game");
	setcolor(15);
	outtextxy(207,2,"TURBO CHECKERS");
	display_board();
	setcolor(15);
	line(490,51,625,51);
	rectangle(490,128,625,143);
	line(490,230,625,230);
	settextstyle(0,0,0);
	outtextxy(500,239,"F1  Move piece");
	outtextxy(500,251,"F2  New game");
	outtextxy(500,263,"F3  Load game");
	outtextxy(500,275,"F4  Save game");
	outtextxy(500,287,"F5  New players");
	outtextxy(500,299,"F10 Quit"); }

init_variables()
{	strcpy(playr[0],"(none)");
	strcpy(playr[1],"(none)");
	kings[0]=kings[1]=0;
	pieces_taken[0]=pieces_taken[1]=0;
	quitgame=FALSE;
	plyr=-1;
	plyr_chk=FALSE; }

display_board()
{    register int y;

     setcolor(7);
      for (y=5;y<485;y+=59)
            line(y,36,y,315);
     for (y=36;y<325;y+=35)
            line(5,y,477,y);
      for (y=0;y<8;y++)
	  {    register int x,n;

            if (y==1 || y==3 ||
              y==5 || y==7)
                  n=5;
          else
                  n=64;
            for (x=n;x<440;x+=118)
				  fill(x+30,(y*35)+53,1,12,7); } }

init_playrs()
{   register int x;

	for (x=0;x<8;x++)
	{   register int y;

		for (y=0;y<8;y++)
			board[y][x]=-1; }
	for (x=0;x<8;x+=2)
	{   board[x][0]=0;
		board[x+1][1]=0;
		board[x][2]=0;
		board[x+1][5]=1;
		board[x][6]=1;
		board[x+1][7]=1; }
	for (x=0;x<8;x++)
	{	register int y,a;

		if (x==0 || x==2 || x==4 || x==6)
			a=0;
		else
			a=1;
		for (y=a;y<8;y+=2)
		{	clear_square(y,x);
			if (board[y][x]!=-1)
				put_piece(y,x,board[y][x]); } }
	plyr=0;
	pieces_taken[0]=pieces_taken[1]=0;
	kings[0]=kings[1]=0;
	information(FALSE); }

winner(int p)
{	char str[80];

	strcpy(str,playr[p]);
	strcat(str," has won the game!!!");
	gotoxy(40-(strlen(str)/2),24);
	printf("%s",str);
	{	int t;

		for (t=1;t<4;t++)
			for (p=100;p<2000;p+=40)
			{	sound(p);
				delay(10);
				nosound(); } } }

save_game()
{   int  x,y;
	char str[80];
	FILE *fname;

	clrtext();
	print(1,"Enter the filename (w/o .ext): ");
	scanf("%s",str);
	clrtext();
	center("Writing file...");
	strcat(str,".gam");
	fname=fopen(str,"w");
	fprintf(fname,"%d,%d\n",kings[0],pieces_taken[0]);
	fprintf(fname,"%d,%d\n",kings[1],pieces_taken[1]);
	fprintf(fname,"%s\n%s\n",playr[0],playr[1]);
	fprintf(fname,"%d\n",plyr);
	for (y=0;y<8;y++)
		for (x=0;x<8;x++)
			if (board[x][y]!=-1)
				fprintf(fname,"%d,%d,%d,",x,y,board[x][y]);
	fclose(fname);
	clrtext(); }

int load_game()
{	int  n;
	char str[80];
	FILE *fname;

	clrtext();
	print(1,"Enter the filename (w/o .ext): ");
	scanf("%s",str);
	strcat(str,".gam");
	if ((fname=fopen(str,"r"))==NULL)
	{	beep();
		clrtext();
		center("Error - File not found");
		beep();
		delay(1500);
		return 0; }
	clrtext();
	center("Reading file...");
	for (n=0;n<8;n++)
	{	int a;
		for (a=0;a<8;a++)
			board[a][n]=-1; }
	fscanf(fname,"%d,%d\n",&kings[0],&pieces_taken[0]);
	fscanf(fname,"%d,%d\n",&kings[1],&pieces_taken[1]);
	fscanf(fname,"%s\n%s\n",playr[0],playr[1]);
	fscanf(fname,"%d\n",&plyr);
	while (!feof(fname))
	{   int x,y,v;

		fscanf(fname,"%d,%d,%d,",&x,&y,&v);
		board[x][y]=v; }
	fclose(fname);
	clrtext();
	plyr_chk=TRUE;
	return 1; }

instructions()
{	int  num=0;
	char c,str[80];
	FILE *fname;

	cleardevice();
	if ((fname=fopen("instruct.txt","r"))==NULL)
	{	beep();
		return; }
	printf("\n\n\n              1 - Display instructions on screen");
	printf("\n              2 - Print the instructions");
	printf("\n              3 - Cancel instructions");
	tolower(c=getch());
	if (c=='1')
	{	cleardevice();
		printf("\n                                 Instructions\n\n");
		while (!feof(fname))
		{	while (!feof(fname) && num<21)
			{	fgets(str,80,fname);
				printf("%s",str);
				num++; }
			num=0;
			printf("                             Press any key\n");
			getch(); } }
	if (c=='2')
	{	while (!feof(fname))
		{	fgets(str,80,fname);
			fprintf(stdprn,"%s",str); } }
	fclose(fname); }

cursor(int x,int y,int blink)
{	if (blink)
	{	setcolor(10);
		rectangle((x*59)+7,(y*35)+37,(x*59)+62,(y*35)+70);
		delay(70);
		setcolor(0);
		rectangle((x*59)+7,(y*35)+37,(x*59)+62,(y*35)+70);
		delay(5); }
	else
	{	setcolor(13);
		rectangle((x*59)+7,(y*35)+37,(x*59)+62,(y*35)+70); } }

clrtext()
{	register int x;

	for (x=7;x<75;x++)
	{	gotoxy(x,24);
		printf(" "); } }

print(int x,char *str)
{	gotoxy(x+6,24);
	printf("%s",str); }

center(char *str)
{	gotoxy(40-(strlen(str)/2),24);
	printf("%s",str); }

put_piece(int x,int y,int colr)
{	int clr;


	if (colr==0 || colr==10)
		clr=12;
	else
		clr=0;
	setcolor(15);
	circle((x*59)+31,(y*35)+53,15);
	fill((x*59)+31,(y*35)+53,1,clr,15);
	ellipse((x*59)+31,(y*35)+53,245,25,16,12);
	if (colr>1)
	{	settextstyle(1,0,0);
		setusercharsize(1,2,1,2);
		outtextxy((x*59)+27,(y*35)+44,"K");
		setusercharsize(1,1,1,1); } }

information(int full)
{	char str[2][5];

	settextstyle(2,0,0);
	if (full)
	{	setcolor(11);
		outtextxy(500,38,"Player 1");
		outtextxy(500,130,"Player 2");
		outtextxy(500,60,"Pieces taken :");
		outtextxy(500,152,"Pieces taken :");
		outtextxy(500,80,"Kings :");
		outtextxy(500,172,"Kings :");
		outtextxy(500,100,"Color :");
		outtextxy(500,192,"Color :");
		setcolor(8);
		rectangle(558,37,624,50);
		rectangle(558,129,624,142);
		fill(565,40,1,0,8);
		fill(565,135,1,0,8);
		setcolor(0);
		rectangle(558,37,624,50);
		rectangle(558,129,624,142);
		setcolor(15);
		outtextxy(560,38,playr[0]);
		outtextxy(560,130,playr[1]);
		rectangle(595,100,610,110);
		rectangle(595,192,610,202);
		fill(600,105,1,12,15); }
	setcolor(8);
	rectangle(595,52,615,95);
	rectangle(595,144,615,187);
	fill(600,55,1,0,8);
	fill(600,150,1,0,8);
	setcolor(0);
	rectangle(595,52,615,95);
	rectangle(595,144,615,187);
	setcolor(15);
	itoa(pieces_taken[0],str[0],10);
	itoa(kings[0],str[1],10);
	outtextxy(600,60,str[0]);
	outtextxy(600,80,str[1]);
	itoa(pieces_taken[1],str[0],10);
	itoa(kings[1],str[1],10);
	outtextxy(600,152,str[0]);
	outtextxy(600,172,str[1]); }

clear_square(int x,int y)
{	fill((x*59)+31,(y*35)+53,1,0,7); }

int quit_program()
{   char c='';

	clrtext();
	gotoxy(7,24);
	printf("Are you sure (Y/N)? ");
	while (c!='n' && c!='y')
	{	gotoxy(27,24);
		tolower(c=getche()); }
	clrtext();
	if (c=='y')
		return TRUE;
	else
		return FALSE; }

check_players()
{   char temp[15];

	if (plyr_chk)
		return;
	plyr_chk=TRUE;
	clrtext();
	print(2,"Enter player 1's name: ");
	scanf("%10s",playr[0]);
	clrtext();
	print(2,"Enter player 2's name: ");
	scanf("%10s",playr[1]);
	clrtext();
	setcolor(8);
	rectangle(555,37,624,50);
	rectangle(555,129,624,142);
	fill(560,40,1,0,8);
	fill(560,135,1,0,8);
	setcolor(0);
	rectangle(555,37,624,50);
	rectangle(555,129,624,142);
	strupr(playr[0]);
	strupr(playr[1]);
	if (!strcmp(playr[1],"COMPUTER"))
	{	strcpy(playr[1],playr[0]);
		strcpy(playr[0],"COMPUTER"); }
	setcolor(15);
	outtextxy(560,38,playr[0]);
	outtextxy(560,130,playr[1]); }

int move()
{	int  px,py,x[10],y[10],
		 num,jmp=FALSE,inc_x[10],
		 inc_y[10],kng=FALSE;
	char c='';

	px=4;py=4;
	for (num=0;num<10;num++)
		inc_x[num]=inc_y[num]=0;
	num=0;
	if (plyr==0)
		center("Player 1's turn");
	else
		center("Player 2's turn");
	while (c!=ESC)
	{	c='';
		while (c!=F1 && num!=10 && c!=ESC)
		{	if (!strcmp(playr[plyr],"COMPUTER"))
				computer_move();
			if (pieces_taken[0]<12 && pieces_taken[1]<12) {
			while (!kbhit())
				cursor(px,py,TRUE);
			c=getch();
			{	register int a;
        					for (a=0;a<num;a++)
					cursor(x[a],y[a],FALSE); }
			switch(c)
			{	case UP:		py-=2;break;
				case DOWN:		py+=2;break;
				case RIGHT:		px+=2;break;
				case LEFT:		px-=2;break;
				case PGUP:		px++;py--;break;
				case PGDN:		px++;py++;break;
				case END:		px--;py++;break;
				case HOME:		px--;py--; }
			if (px==-1) px=1;
			if (px==-2) px=0;
			if (px==8) px=6;
			if (px==9) px=7;
			if (py==-1) py=1;
			if (py==-2) py=0;
			if (py==8) py=6;
			if (py==9) py=7;
			if (c==F2 || c==F3 || c==F5 || c==F10)
			{	center("You must first press <ESC>");
				beep();
				delay(1200);
				clrtext(); }
			if (c==F4)
			{	save_game();
				if (plyr==0)
					center("Player 1's turn");
				else
					center("Player 2's turn"); }
			if (c==F1 && num<2)
			{	beep();
				c=''; }
			if (c==13)
			{	if (board[px][py]==-1)
				{	inc_x[num]=px-x[num-1];
					inc_y[num]=py-y[num-1];
					if (abs(inc_x[num])<3 && abs(inc_y[num])<3 &&
						board[x[0]][y[0]]>1)
					{	if (abs(inc_x[num])==1 && abs(inc_y[num])==1 && jmp==FALSE)
						{	x[num]=px;
							y[num]=py;
							num++;
							cursor(px,py,FALSE); }
						if (abs(inc_x[num])==2 && abs(inc_y[num])==2 &&
							(num==1 || jmp==TRUE))
							{   int m;

							m=plyr;
							m++;
							if (m==2)
								m=0;
							if (board[x[num-1]+(inc_x[num]/2)][y[num-1]+(inc_y[num]/2)]==m)
							{	x[num]=px;
								y[num]=py;
									num++;
									cursor(px,py,FALSE);
									jmp=TRUE; }
								if (board[x[num-1]+(inc_x[num]/2)][y[num-1]+(inc_y[num]/2)]==m+10)
								{	x[num]=px;
									y[num]=py;
									num++;
									cursor(px,py,FALSE);
									jmp=TRUE; } } }
					else
					{	if ((inc_y[num]==1 && abs(inc_x[num])==1 && plyr==0) ||
							(inc_y[num]==-1 && abs(inc_x[num])==1 && plyr==1))
							if (num==1)
							{	x[num]=px;
								y[num]=py;
								num++;
								cursor(px,py,FALSE);
								if ((py==7 && plyr==0) || (py==0 && plyr==1))
									kng=TRUE; }
						if ((inc_y[num]==2 && abs(inc_x[num])==2 && plyr==0) ||
							(inc_y[num]==-2 && abs(inc_x[num])==2 && plyr==1) ||
							(abs(inc_x[num])==2 && abs(inc_y[num])==2 &&
							kng==TRUE) && (jmp==TRUE || num==1))
						{	int m;
								m=plyr;
							m++;
							if (m==2)
								m=0;
							if (board[x[num-1]+(inc_x[num]/2)][y[num-1]+(inc_y[num]/2)]==m)
							{	jmp=TRUE;
								x[num]=px;
								y[num]=py;
								if ((py==7 && plyr==0) || (py==0 && plyr==1))
									kng=TRUE;
								num++;
								cursor(px,py,FALSE); }
							if (board[x[num-1]+(inc_x[num]/2)][y[num-1]+(inc_y[num]/2)]==m+10)
							{	jmp=TRUE;
								x[num]=px;
								y[num]=py;
								num++;
								cursor(px,py,FALSE); } } } }
				if (board[px][py]!=-1)
				{	if (board[px][py]==plyr || board[px][py]==plyr+10)
					{	register int a;
							for (a=0;a<num;a++)
						{	cursor(x[a],y[a],TRUE);
							inc_x[a]=inc_y[a]=0; }
						num=0;jmp=FALSE;
						x[num]=px;
						y[num]=py;
						num++;
						cursor(px,py,FALSE); }
					else
					{	beep();
						c=''; } } } } }
		if (c!=ESC)
		{   int valu,t;

			clear_square(x[0],y[0]);
			valu=board[x[0]][y[0]];
			board[x[0]][y[0]]=-1;
			for (t=1;t<num;t++)
			{	put_piece(x[t],y[t],valu);
				board[x[t]][y[t]]=-1;
				if (jmp)
				{	board[x[t-1]+(inc_x[t]/2)][y[t-1]+(inc_y[t]/2)]=-1;
					clear_square(x[t-1]+(inc_x[t]/2),y[t-1]+(inc_y[t]/2));
					pieces_taken[plyr]++;
					if (kng==TRUE && ((y[t]==7 && plyr==0) || (y[t]==0 && plyr==1)))
					{	valu+=10;
						put_piece(x[t],y[t],valu);
						kings[plyr]++;
						kng=FALSE; }
					information(FALSE);
					if (pieces_taken[plyr]==12)
					{   cursor(x[t-1],y[t-1],TRUE);
						return plyr; } }
				delay(350);
				if (t<num-1)
				clear_square(x[t],y[t]); }
			cursor(x[num-1],y[num-1],TRUE);
			board[x[num-1]][y[num-1]]=valu;
			if ((plyr==0 && y[num-1]==7) || (plyr==1 && y[num-1]==0) &&
				board[x[num-1]][y[num-1]]<2 && kng==TRUE)
			{	board[x[num-1]][y[num-1]]=plyr+10;
				put_piece(x[num-1],y[num-1],board[x[num-1]][y[num-1]]);
				kings[plyr]++;
				information(FALSE); }
			for (t=0;t<num;t++)
				x[t]=y[t]=0;
		for (num=0;num<10;num++)
			inc_x[num]=inc_y[num]=0; }
		num=0;jmp=FALSE;
		plyr++;kng=FALSE;
		if (plyr==2)
		{	plyr=0;
			center("Player 1's turn"); }
		else
			center("Player 2's turn"); }
	clrtext();
	for (px=0;px<num;px++)
		cursor(x[px],y[px],TRUE);
	return -1; }

computer_move()
{	int a;

	cnum=0;
	cjmp=FALSE;
	if (!block_jump(0,0))
		if (!make_jump(0,0))
			if (!get_king(0,0))
				if (!move_king(0,0))
					if (!make_move(0,0))
						pick_move(0,0);
	if (pieces_taken[1]==12)
		return;
	a=board[cx[0]][cy[0]];
	board[cx[0]][cy[0]]=-1;
	clear_square(cx[0],cy[0]);
	if (cy[1]==7 && a<2)
	{   a+=10;
		kings[plyr]++;
		information(FALSE); }
	board[cx[1]][cy[1]]=a;
	put_piece(cx[1],cy[1],a);
	if (cjmp)
	{	board[(cx[0]+cx[1])/2][(cy[0]+cy[1])/2]=-1;
		clear_square((cx[0]+cx[1])/2,(cy[0]+cy[1])/2);
		pieces_taken[plyr]++;
		information(FALSE); }
	plyr++;
	if (plyr==0)
		center("Player 1's turn");
	else
		center("Player 2's turn"); }

int block_jump(int x,int y)
{   register int a,px,py,mx,my;

	if (y==8)
		return 0;
	if (x<8)
		block_jump(x+1,y);
	else
	{	x=0;
		block_jump(x,y+1); }
	if (cnum!=0)
		return 1;
	if ((board[x][y]!=plyr) && (board[x][y]!=(plyr+10)))
		return 0;
	a=1;
	px=py=-1;
	if ((board[x+1][y-1]==(a+10)) && board[x-1][y+1]==-1)
	{	px=x-1;
		py=y+1; }
	if ((board[x-1][y-1]==(a+10)) && board[x+1][y+1]==-1)
	{	px=x+1;
		py=y+1; }
	if ((board[x-1][y+1]==a) ||	(board[x-1][y+1]==(a+10)) &&
		board[x+1][y-1]==-1)
	{	px=x+1;
		py=y-1; }
	if ((board[x+1][y+1]==a) ||	(board[x+1][y+1]==(a+10)) &&
		board[x-1][y-1]==-1)
	{	px=x-1;
		py=y-1; }
	if (px<0 || py<0 || px>7 || py>7 || board[px][py]!=-1)
		return 0;
	mx=my=-1;
	if ((board[px+1][py-1]==plyr) || (board[px+1][py-1]==(plyr+10)))
	{	mx=px+1;
		my=py-1; }
	if (board[px+1][py+1]==(plyr+10))
	{	mx=px+1;
		my=py+1; }
	if (board[px-1][py+1]==(plyr+10))
	{	mx=px-1;
		my=py+1; }
	if ((board[px-1][py-1]==plyr) || (board[px-1][py-1]==(plyr+10)))
	{	mx=px-1;
		my=py-1; }
	if (mx<0 || my<0 || mx>7 || my>7 || (board[mx][my]!=plyr ||
		board[mx][my]!=(plyr+10)))
		return 0;
	cnum=2;
	cx[0]=mx;cy[0]=my;
	cx[1]=px;cy[1]=py;
	return 1; }

int get_king(int x,int y)
{   register int mx,my;

	if (y==8)
		return 0;
	if (x<8)
		get_king(x+1,y);
	else
	{   x=0;
		get_king(x,y+1); }
	if (cnum!=0)
		return 1;
	if (board[x][y]!=plyr)
		return 0;
	mx=my=-1;
	if ((y+1)==7 && (board[x+1][y+1]==-1 || board[x-1][y+1]==-1) &&
		plyr==0)
	{	if (board[x+1][y+1]==-1)
		{	mx=x+1;
			my=y+1; }
		if (board[x-1][y+1]==-1)
		{	mx=x-1;
			my=y+1; } }
	if ((y-1)==0 && (board[x+1][y-1]==-1 || board[x-1][y-1]==-1) &&
		plyr==1)
	{	if (board[x+1][y-1]==-1)
		{	mx=x+1;
			my=y-1; }
		if (board[x-1][y-1]==-1)
		{	mx=x-1;
			my=y-1; } }
	if (mx<0 || my<0 || mx>7 || my>7)
		return 0;
	cnum=2;
	cx[0]=x;cy[0]=y;
	cx[1]=mx;cy[1]=my;
	return 1; }

int make_jump(int x,int y)
{	register int a,mx,my;

	if (y==8)
		return 0;
	if (x<8)
		make_jump(x+1,y);
	else
	{	x=0;
		make_jump(x,y+1); }
	if (cnum!=0)
		return 1;
	if ((board[x][y]!=plyr) && (board[x][y]!=(plyr+10)))
		return 0;
	a=1;
	mx=my=-1;
	if ((board[x+1][y+1]==a || board[x+1][y+1]==(a+10)) &&
		((board[x][y+2]!=a && board[x][y+2]!=(a+10) && board[x+2][y]!=-1) &&
		 (board[x+2][y]!=(a+10) && board[x][y+2]!=-1) ||
		(board[x-1][y-1]==-1)) && board[x+2][y+2]==-1)
	{	mx=x+2;
		my=y+2; }
	if ((board[x-1][y+1]==a || board[x-1][y+1]==(a+10)) &&
		((board[x][y+2]!=a && board[x][y+2]!=(a+10) && board[x-2][y]!=-1) &&
		 (board[x-2][y]!=(a+10) && board[x][y+2]!=-1) ||
		(board[x+1][y-1]==-1)) && board[x-2][y+2]==-1)
	{	mx=x-2;
		my=y+2; }
	if ((board[x-1][y-1]==a || board[x-1][y-1]==11) &&
		board[x][y]==10 &&
		((board[x-2][y]!=a && board[x-2][y]!=11 && board[x][y-2]!=-1) &&
		 (board[x][y-2]!=11 && board[x-2][y]!=-1) ||
		 (board[x+1][y+1]==-1)) && board[x-2][y-2]==-1)
	{	mx=x-2;
		my=y-2; }
	if ((board[x+1][y-1]==a || board[x+1][y-1]==(a+10)) &&
		board[x][y]==10 &&
		((board[x+2][y]!=a && board[x+2][y]!=(a+10) && board[x][y-2]!=-1) &&
		 (board[x][y-2]!=(a+10) && board[x+2][y]!=-1) ||
		 (board[x-1][y+1]==-1)) && board[x+2][y-2]==-1)
	{	mx=x+2;
		my=y-2; }
	if (mx<0 || my<0 || mx>7 || my>7 || board[mx][my]!=-1)
		return 0;
	cjmp=TRUE;
	cnum=2;
	cx[0]=x;cy[0]=y;
	cx[1]=mx;cy[1]=my;
	return 1; }

int make_move(int x,int y)
{	register int a,mx,my;

	if (y==8)
		return 0;
	if (x<8)
		make_move(x+1,y);
	else
	{	x=0;
		make_move(x,y+1); }
	if (cnum!=0)
		return 1;
	if ((board[x][y]!=plyr) && (board[x][y]!=(plyr+10)))
		return 0;
	a=1;
	mx=my=-1;
	if (y==0 && pieces_taken[a]<7)
		return 0;
	if (board[x+1][y+1]==-1 && (plyr==0 || plyr==10) &&
		(board[x+2][y+2]!=a && board[x][y+2]!=a &&
		 board[x+2][y+2]!=a+10 && board[x][y+2]!=a+10 &&
		 board[x+2][y]!=a+10))
	{	mx=x+1;
		my=y+1; }
	if (board[x-1][y+1]==-1 && (plyr==0 || plyr==10) &&
		(board[x-2][y+2]!=a && board[x][y+2]!=a &&
		 board[x-2][y+2]!=a+10 && board[x][y+2]!=a+10 &&
		 board[x-2][y]!=a+10))
	{	mx=x-1;
		my=y+1; }
	if (board[x-1][y-1]==-1 && plyr==10 &&
		(board[x-2][y-2]!=a && board[x][y-2]!=a &&
		 board[x-2][y-2]!=a+10 && board[x][y-2]!=a &&
		 board[x-2][y]!=a+10))
	{	mx=x-1;
		my=y-1; }
	if (board[x+1][y-1]==-1 && plyr==10 &&
		(board[x+2][y-2]!=a && board[x][y-2]!=a &&
		 board[x+2][y-2]!=a+10 && board[x][y-2]!=a+10 &&
		 board[x+2][y]!=a+10))
	{	mx=x+1;
		my=y-1; }
	if (mx<0 || my<0 || mx>7 || my>7 || board[mx][my]!=-1)
		return 0;
	cnum=2;
	cx[0]=x;cy[0]=y;
	cx[1]=mx;cy[1]=my;
	return 1; }

int pick_move(int x,int y)
{	register int mx,my;

	if (y==8)
		return 0;
	if (x<8)
		pick_move(x+1,y);
	else
	{	x=0;
		pick_move(x,y+1); }
	if (cnum!=0)
		return 0;
	if ((board[x][y]!=plyr) && (board[x][y]!=(plyr+10)))
		return 0;
	if (y==0 && pieces_taken[1]<7)
		return 0;
	mx=my=-1;
	if (board[x+1][y+1]==-1 && (plyr==0 || plyr==10))
	{	mx=x+1;
		my=y+1; }
	if (board[x-1][y+1]==-1 && (plyr==0 || plyr==10))
	{	mx=x-1;
		my=y+1; }
	if (board[x-1][y-1]==-1 && plyr==10)
	{	mx=x-1;
		my=y-1; }
	if (board[x+1][y-1]==-1 && plyr==10)
	{	mx=x+1;
		my=y-1; }
	if (mx<0 || my<0 || mx>7 || my>7 || board[mx][my]!=-1)
		return 0;
	cnum=2;
	cx[0]=x;cy[0]=y;
	cx[1]=mx;cy[1]=my;
	return 1; }

int move_king(int x,int y)
{	register int a,mx,my;

	if (y==8)
		return 0;
	if (x<8)
		move_king(x+1,y);
	else
	{	x=0;
		move_king(x,y+1); }
	if (cnum!=0)
		return 1;
	if (board[x][y]!=10)
		return 0;
	a=plyr+1;
	if (a==2)
		a=0;
	mx=my=-1;
	if (board[x+1][y-1]==-1 && (board[x+2][y]!=a && board[x+2][y]!=(a+10)) &&
		board[x][y-2]!=(a+10) && board[x+2][y+2]!=(a+10))
	{	mx=x+1;
		my=y-1; }
	if (board[x-1][y-1]==-1 && (board[x-2][y]!=a && board[x-2][y]!=(a+10)) &&
		board[x-2][y-2]!=(a+10) && board[x][y-2]!=(a+10))
	{	mx=x-1;
		my=y-1; }
	if (board[x+1][y+1]==-1 && (board[x][y+2]!=a && board[x][y+2]!=(a+10)) &&
		(board[x+2][y+2]!=a && board[x+2][y+2]!=(a+10)) &&
		board[x+2][y]!=(a+10))
	{	mx=x+1;
		my=y+1; }
	if (board[x-1][y+1]==-1 && (board[x][y+2]!=a && board[x][y+2]!=(a+10)) &&
		(board[x-2][y+2]!=a && board[x-2][y+2]!=(a+10)) &&
		board[x-2][y]!=(a+10))
	{	mx=x-1;
		my=y+1; }
	if (mx<0 || my<0 || mx>7 || my>7 || board[mx][my]!=-1)
		return 0;
	cnum=2;
	cx[0]=x;cy[0]=y;
	cx[1]=mx;cy[1]=my;
	return 1; }
